searchNodes=[{"doc":"Symbolic Math for Elixir, with Units support","ref":"Exun.html","title":"Exun","type":"module"},{"doc":"","ref":"Exun.html#debug/0","title":"Exun.debug/0","type":"function"},{"doc":"Parse and evaluate an expression. If ast is true returns de AST tuple, if it is false return a human-readable (and parseable) expression. iex&gt; Exun.eval &quot;x[m^2]+4[cm^2]&quot;,%{&quot;x&quot;=&gt;&quot;3&quot;} &quot;3.0004[m^2]&quot;","ref":"Exun.html#eval/2","title":"Exun.eval/2","type":"function"},{"doc":"Same as eval but returns AST","ref":"Exun.html#eval_ast/2","title":"Exun.eval_ast/2","type":"function"},{"doc":"Parse a math expression, not a 'equality', with context definitions For example, express 'x' squared meters, and then define x to be 3. iex&gt; Exun.parse( &quot;x[m^2]&quot;, %{&quot;x&quot;=&gt;&quot;3&quot;}) {{:unit, {:vari, &quot;x&quot;}, {:elev, {:vari, &quot;m&quot;}, {:numb, 2}}}, %{{:vari, &quot;x&quot;} =&gt; {:numb, 3}}} returns a tuple {expression, parsed_conext} where expression is a tuple that holds math AST and parsed_context is a map whith all equalities (definitions) parsed as &quot;name&quot; =&gt; expression","ref":"Exun.html#parse/2","title":"Exun.parse/2","type":"function"},{"doc":"","ref":"Exun.html#parse_text/1","title":"Exun.parse_text/1","type":"function"},{"doc":"Replace definitions in context into main tree expression until no more expansion is posssible","ref":"Exun.html#replace/2","title":"Exun.replace/2","type":"function"},{"doc":"Collect Math expression, try to simplify","ref":"Exun.Collect.html","title":"Exun.Collect","type":"module"},{"doc":"Main collecting function. Try to simplify tree without chaging its value Gets and returns an AST, as produced by Exun.parse.","ref":"Exun.Collect.html#coll/1","title":"Exun.Collect.coll/1","type":"function"},{"doc":"Check cyclic definitions in context","ref":"Exun.Cyclic.html","title":"Exun.Cyclic","type":"module"},{"doc":"Get a list of variables down a tree, checking cyclic definition from 'context' user defs. Check cyclic definitions in 'context', a map that holds values like %{&quot;f&quot; =&gt; &quot;x^2+2*x+3&quot;}. If you pass a cyclic map this function detects it, for example:%{&quot;a&quot;=&gt;&quot;b&quot;, &quot;b&quot;=&gt;&quot;c&quot;, &quot;c&quot;=&gt;&quot;a&quot;}","ref":"Exun.Cyclic.html#check/1","title":"Exun.Cyclic.check/1","type":"function"},{"doc":"Derivate expressions","ref":"Exun.Der.html","title":"Exun.Der","type":"module"},{"doc":"Derive function txt for variable x, return string","ref":"Exun.Der.html#deriv/2","title":"Exun.Der.deriv/2","type":"function"},{"doc":"Compares two expressions","ref":"Exun.Eq.html","title":"Exun.Eq","type":"module"},{"doc":"Denormalize tree, reverse of norm","ref":"Exun.Eq.html#denorm/1","title":"Exun.Eq.denorm/1","type":"function"},{"doc":"Tree equality, normalize compounds '' and '+' because {,{,1,2},{,3,4}} == {,{,1,3},{,2,4}} so transform both trees to {{:m,}[1,2,3,4]} before compare","ref":"Exun.Eq.html#eq/2","title":"Exun.Eq.eq/2","type":"function"},{"doc":"Normalize tree so :mult and :suma are converted to list: {:mult,{:mult,a,b},c} -&gt; {{:m,:mult},[a,b,c]}","ref":"Exun.Eq.html#norm/1","title":"Exun.Eq.norm/1","type":"function"},{"doc":"Function management. @base and @compound are the definitions of external functions.","ref":"Exun.Fun.html","title":"Exun.Fun","type":"module"},{"doc":"base is a map that holds functions names and a tupla &lt;fname&gt;(F) { &lt;elixir function call reference for numbers&gt;, &quot;Deriv Abstract&quot;} For example: ln(F) Function name is 'ln' {&amp;:math.log/1, &quot;F'x/F&quot;} F'x is d(F)/dx","ref":"Exun.Fun.html#base/0","title":"Exun.Fun.base/0","type":"function"},{"doc":"","ref":"Exun.Fun.html#compounds/0","title":"Exun.Fun.compounds/0","type":"function"},{"doc":"","ref":"Exun.Fun.html#fcall/2","title":"Exun.Fun.fcall/2","type":"function"},{"doc":"","ref":"Exun.Fun.html#replace_args_internal/3","title":"Exun.Fun.replace_args_internal/3","type":"function"},{"doc":"Try to integrate function","ref":"Exun.Integral.html","title":"Exun.Integral","type":"module"},{"doc":"","ref":"Exun.Integral.html#check_parts/2","title":"Exun.Integral.check_parts/2","type":"function"},{"doc":"","ref":"Exun.Integral.html#doparts/3","title":"Exun.Integral.doparts/3","type":"function"},{"doc":"","ref":"Exun.Integral.html#integ/2","title":"Exun.Integral.integ/2","type":"function"},{"doc":"","ref":"Exun.Integral.html#parts/2","title":"Exun.Integral.parts/2","type":"function"},{"doc":"Exun is intense in tuple management and recursion. This module is a try to buil tuple's element in parallel using Task. The macro mp is responsible for that.","ref":"Exun.MProc.html","title":"Exun.MProc","type":"module"},{"doc":"","ref":"Exun.MProc.html#mp/1","title":"Exun.MProc.mp/1","type":"macro"},{"doc":"Build tuple in async mode, so every element of the tuple is spawned in its own process. Only for tuple sizes greater than 2For example::timer.tc(fn -&gt; {:timer.sleep(1000), :timer.sleep(1000), :timer.sleep(1000)} end) {3002269, {:ok, :ok, :ok}}:timer.tc(fn -&gt; mp {:timer.sleep(1000), :timer.sleep(1000), :timer.sleep(1000)} end) {1001001, {:ok, :ok, :ok}}","ref":"Exun.MProc.html#parallel/2","title":"Exun.MProc.parallel/2","type":"macro"},{"doc":"Simple transformation of a tree","ref":"Exun.Math.html","title":"Exun.Math","type":"module"},{"doc":"Change power sign of AST (expon * -1 or 1/tree)","ref":"Exun.Math.html#chpow/1","title":"Exun.Math.chpow/1","type":"function"},{"doc":"Change sign of AST","ref":"Exun.Math.html#chsign/1","title":"Exun.Math.chsign/1","type":"function"},{"doc":"Match ASTs","ref":"Exun.Pattern.html","title":"Exun.Pattern","type":"module"},{"doc":"","ref":"Exun.Pattern.html#allones?/1","title":"Exun.Pattern.allones?/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#check_cond/2","title":"Exun.Pattern.check_cond/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#check_conds/2","title":"Exun.Pattern.check_conds/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#checkmap/3","title":"Exun.Pattern.checkmap/3","type":"function"},{"doc":"Get any combination from list that supports ssets spec","ref":"Exun.Pattern.html#combin/2","title":"Exun.Pattern.combin/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#concatlist/1","title":"Exun.Pattern.concatlist/1","type":"function"},{"doc":"take a list an generate all possible list varying order of elements list can be of tye [a, [b,c],d] but b and c cannot be lists must produce [ [a,[b,c],d], [a,[c,b],d], [a,d,[b,c]], [a,d,[c,b]], [d,a,[b,c]], [d,a,[c,b]], [[b,c],a,d], [[b,c],d,a], [[c,b],a,d], [[c,b],d,a], ]","ref":"Exun.Pattern.html#expand_order/1","title":"Exun.Pattern.expand_order/1","type":"function"},{"doc":"Extract sublist of l of size sizes extract [1,2,3,4,5],[1,2,2] -&gt; [[1],[2,3],[4,5]]","ref":"Exun.Pattern.html#extract/2","title":"Exun.Pattern.extract/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#match/4","title":"Exun.Pattern.match/4","type":"function"},{"doc":"","ref":"Exun.Pattern.html#match_ast/3","title":"Exun.Pattern.match_ast/3","type":"function"},{"doc":"deriv match in two situations: if name is yet in map, its definition must be equal to exp. If not it will match if we can integrate expr; initially we ca use symbolic integration, but if in conditions name is used without deriv, the condition will no be true if we can not integrate it.","ref":"Exun.Pattern.html#mderiv/3","title":"Exun.Pattern.mderiv/3","type":"function"},{"doc":"Match a function definition as matching f(x,y) &lt;-&gt; &quot;xy&quot;, so put in map the match f=xy if f is not yet defined or it is and equals x*y","ref":"Exun.Pattern.html#mfdef/3","title":"Exun.Pattern.mfdef/3","type":"function"},{"doc":"Match integral, only allowed as abstract form &quot;$f,x&quot;","ref":"Exun.Pattern.html#minteg/3","title":"Exun.Pattern.minteg/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#mklist_byindex/2","title":"Exun.Pattern.mklist_byindex/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#mknumber/2","title":"Exun.Pattern.mknumber/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#mlist/3","title":"Exun.Pattern.mlist/3","type":"function"},{"doc":"All possible matchings from l2 to l1. l2 must be equal or greater in lenght, if not there is no possible match. Caller must comlpete l2 with 'unity', this is not going to happend here. l1 is abstract, l2 a real expression. # if map holds any definition from l1, match it before generalize; if we can't, return ko # if yes, reduce l2 and l1 for that definitions. We have to substitute map values into l1 # and then perform match # For now, try direct match; sin florituras","ref":"Exun.Pattern.html#mmult/3","title":"Exun.Pattern.mmult/3","type":"function"},{"doc":"General matching function Try to match an abstract expresion agains real expression, for example abstract expression: u(x)*v(x)'x real expression: sin(x)^2match u(x) = sin(x) and v(x)'x= sin(x) so v(x)=-cos(x)u and v will be return in a map: %{&quot;u(x)&quot;=&gt;&quot;sin(x)&quot;, &quot;v(x)&quot;=&gt;&quot;-cos(x)&quot;}return a list of tuples {:ok, matched_defs} or {:ko, matched_defs} matched_defs is a map that holds definitions","ref":"Exun.Pattern.html#mnode/3","title":"Exun.Pattern.mnode/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#permute/1","title":"Exun.Pattern.permute/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#rcombin/3","title":"Exun.Pattern.rcombin/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#sfi/3","title":"Exun.Pattern.sfi/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#single_expand_order/1","title":"Exun.Pattern.single_expand_order/1","type":"function"},{"doc":"Sets each of size group than sums number Exun.Pattern.sizesets 7,4 -&gt; [1, 1, 4, 1], [1, 1, 3, 2], [1, 2, 3, 1], [1, 2, 2, 2]] If you have a {{:m,op}, lst} and wants to pattern match lst against an abstract sum with 'n' variables, for example match '1+2x+3x^2+6x^3' with an abstract tree like 'a^2+b+c^3' so a=sqrt(3)x, b=1+2x, c=crt(6)x we have to try all possible groupings of the sum expression","ref":"Exun.Pattern.html#sizesets/2","title":"Exun.Pattern.sizesets/2","type":"function"},{"doc":"Expand sublists taking one lement from each and building a new list [[a], [b,c]] -&gt; [[a,b],[a,c]] [[a,b]] -&gt; [a,b]","ref":"Exun.Pattern.html#subpermute/1","title":"Exun.Pattern.subpermute/1","type":"function"},{"doc":"Make any possible sets of size n from list without order takeany([],[1,2,3,4],3) -&gt; [[1, 2, 3], [1, 2, 4], [1, 3, 4], [2, 3, 4]]","ref":"Exun.Pattern.html#takeany/3","title":"Exun.Pattern.takeany/3","type":"function"},{"doc":"User function, try to match and prints","ref":"Exun.Pattern.html#umatch/3","title":"Exun.Pattern.umatch/3","type":"function"},{"doc":"Find vars of an expression","ref":"Exun.Pattern.html#vars_of_expr/1","title":"Exun.Pattern.vars_of_expr/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#vars_of_expr/2","title":"Exun.Pattern.vars_of_expr/2","type":"function"},{"doc":"Simplify expressions","ref":"Exun.Simpl.html","title":"Exun.Simpl","type":"module"},{"doc":"","ref":"Exun.Simpl.html#mkrec/1","title":"Exun.Simpl.mkrec/1","type":"function"},{"doc":"Parses a tree and transform to string in User Readable form","ref":"Exun.UI.html","title":"Exun.UI","type":"module"},{"doc":"Translate tree to human readable math expression: iex(1)&gt; {_tree, _deps} = Exun.parse &quot;4*x^(y+1)/z&quot;,%{&quot;z&quot;=&gt;&quot;y+1&quot;} {{:divi, {:mult, {:numb, 4}, {:elev, {:vari, &quot;x&quot;}, {:suma, {:vari, &quot;y&quot;}, {:numb, 1}}}}, {:vari, &quot;z&quot;}}, %{{:vari, &quot;z&quot;} =&gt; {:suma, {:vari, &quot;y&quot;}, {:numb, 1}}}}","ref":"Exun.UI.html#tostr/1","title":"Exun.UI.tostr/1","type":"function"},{"doc":"Handle Units, converts, sum, multiply, transform to SI and factorize","ref":"Exun.Unit.html","title":"Exun.Unit","type":"module"},{"doc":"Convert units, for example iex&gt; import Exun.Unit iex&gt; &quot;120[Km/h]&quot; |&gt; convert(&quot;m/s&quot;) &quot;33.333333333333336[m/s]&quot;","ref":"Exun.Unit.html#convert/3","title":"Exun.Unit.convert/3","type":"function"},{"doc":"Convert first unit to the second unit in convert:u1 = Exun.parse &quot;3[m]&quot; u2 = Exun.parse &quot;1[cm]&quot; Exum.Units.convert(u1,u2,%{}) |&gt; Exum.tostr() &quot;300[cm]&quot;","ref":"Exun.Unit.html#convert_ast/3","title":"Exun.Unit.convert_ast/3","type":"function"},{"doc":"Factorize units, as text: factorize(&quot;2[N]&quot;,&quot;[Kg]&quot;)","ref":"Exun.Unit.html#factorize/3","title":"Exun.Unit.factorize/3","type":"function"},{"doc":"Factorize unit u2 from u1, for example iex(1)&gt; {u1,d} = Exun.parse &quot;1[km*Kg*A/h^2]&quot;, %{} {u2,d} = Exun.parse &quot;1[N]&quot;, %{} factorized = Exun.Unit.factorize(u1,u2,%{}) Exum.Tree.tostr factorized &quot;7.566861148315854e-4[N*A]&quot;","ref":"Exun.Unit.html#factorize_ast/3","title":"Exun.Unit.factorize_ast/3","type":"function"},{"doc":"Shows help about unit Known Units prefixes: E = 1.0e18 G = 1.0e9 K = 1000 M = 1.0e6 P = 1.0e15 T = 1.0e12 a = 1.0e-18 c = 0.01 d = 0.1 f = 1.0e-15 h = 100 m = 0.001 n = 1.0e-9 p = 1.0e-12 u = 1.0e-6Know fundamental units: A = true K = true cd = true g = true m = true mol = true s = trueKnow conversions, you can add more via 'context' lb = 453.59237[g] torr = 133.322368421[Pa] vara = 83.6[cm] W = 1[Kg*m^2/s^3] dyn = 0.00001[Kg*m/s^2] ozt = 31.1034768[g] pie = 30.48[cm] min = 60[s] ozUK = 28.413075[ml] hp = 745.699871582[W] yr = 31556925.9747[s] acre = 4046.87260987[m^2] cal = 4.1868[J] in = 2.54[cm] rd = 5.02921005842[m] galUK = 4.546092[l] J = 1[Kg*m^2/s^2] pdl = 0.1382549544376[N] Btu = 1055.05585262[J] therm = 105506000[J] u = 1.6605402e-24[g] h = 3600[s] qt = 0.946352946[l] gf = 0.00980665[N] ft = 0.3048[m] ozfl = 2.95735295625e-2[l] lbf = 4.44822161526[N] Pa = 1[Kg/m/s^2] cu = 0.2365882365[l] bu = 35239.07[ml] bar = 100000[Pa] l = 100[cm^3] ton = 907.18474[Kg] tonUK = 1016.0469088[Kg] bbl = 158987.294928[ml] chain = 20.1168402337[m] pt = 0.473176473[l] t = 1000[Kg] inH2O = 248.84[Pa] pk = 8809.7675[ml] inHg = 3386.38815789[Pa] ct = 0.2[g] mmHg = 1[torr] N = 101.9716[g*m/s^2] oz = 28.349523125[g] galC = 4.54609[l] pc = 3.08567818585e16[m] mi = 1609.344[m] eV = 1.60217733e-19[J] kip = 4448.22161526[N] Hz = 1[1/s] yd = 91.44[cm] CV = 1[hp] slug = 14.5939029372[Kg] fath = 1.82880365761[m] arroba = 25[lb] d = 86400[s] gal = 3.785411784[l] angstrom = 1.0e-10[m] au = 149597900000[m] atm = 101325[Pa] lyr = 9.46052840488e15[m] tbsp = 14.78676447813[ml] tsp = 4.92892159375[ml] erg = 0.0000001[J] a = 100[m^2] grain = 0.06479891[g] lbt = 373.2417216[g] fbm = 2359.737216[ml] psi = 6894.75729317[Pa]","ref":"Exun.Unit.html#help/0","title":"Exun.Unit.help/0","type":"function"},{"doc":"Sum or Rest of two units","ref":"Exun.Unit.html#sum/4","title":"Exun.Unit.sum/4","type":"function"},{"doc":"Converts unit to International System","ref":"Exun.Unit.html#toSI/1","title":"Exun.Unit.toSI/1","type":"function"}]